#include "../svm-kernel.h"
#include <iostream>
#include <string>

class FooKernel : public GenericKernel {
 public:
  FooKernel() {}
  virtual double Compute(const svm_node *px, const svm_node *py)
  {
	double sum = 0;
	while(px->index != -1 && py->index != -1)
	{
		if(px->index == py->index)
		{
			sum += px->value * py->value;
			++px;
			++py;
		}
		else
		{
			if(px->index > py->index)
				++py;
			else
				++px;
		}			
	}
	return sum;
  }
  virtual void WriteParams(FILE *) {}
  virtual const char* Name() {return name_.c_str();}
  virtual ~FooKernel() {
    std::cerr << "FooKernel successfully destructed" << std::endl;
  }
  
 private:
  static const std::string name_;
};

const std::string FooKernel::name_ = "foo";


extern "C" {
  void *foo_load(FILE *) {
    std::cerr << "FooKernel successfully loaded" << std::endl;
    return static_cast<void *>(new FooKernel());
  }
}
